#! /usr/local/bin/perl

################################################################################
# Copyright (c) 1996-1997 Matthew J. Walker, Craig A. Merlic
# Written for the UCLA Virtual Office Hours Project
# Code can be freely distributed for educational use, as long as header
# remains intact.  See included Copyright and Licensing information.
# For info send email to voh@chem.ucla.edu
################################################################################

# search_archive.pl
# Searches through the archive directory for matching gifs and
# aranges them in alphbetical order acsending linked pages.

$header ="Content-type: text/html\n\n" ; # HTML MIME header
$archive_dir = "/net/etc/httpd/htdocs/VOH/archive";
$archive_link = "/VOH/archive";


&ConvertPostData;

opendir(ARCHIVE_DIR, "$archive_dir") || (&Failure(1)) ;
@files = grep(!/^\.\.?$/, readdir(ARCHIVE_DIR));
foreach $file (@files) {
   ($lowercase_file = $file) =~ tr/[A-Z]/[a-z]/;
   if($lowercase_file =~ /$in{search}/) {
           push(@matches, $file)
   } 
}
closedir(ARCHIVE_DIR) ;

&CreateHTML(@matches);
&Success;



# Subroutines

# ConvertPostData 
# Reads in POST data, converts it to unescaped text, and puts
# one key=value in each member of the list "@in"
# Also creates key/value pairs in %in, using '\0' to separate multiple
# selections

sub ConvertPostData {
  local ($pair, $key, $val);
  if ($ENV{'REQUEST_METHOD'} eq "POST") {
      read(STDIN, $in, $ENV{'CONTENT_LENGTH'});
      
      #Split into key-pairs on '&'
      @in = split(/&/,$in);

      foreach $pair (@in) {
         ($key, $val) = split(/=/, $pair);
         # Convert plus's to spaces
         $val =~ tr/+/ /;
         # Convert %XX from hex numbers to alphanumeric
         $val =~ s/%(..)/pack("C",hex($1))/ge;
         $in{$key} .= '\0' if (defined($in{$key}));
         $in{$key} .= $val;
       } 
   } else {
   (&Failure(5)) ;
   }
}

sub CreateHTML {
   local(@matches) = @_;
   $links = "";
   foreach $file (sort @matches) {
      $links .= "<li><a href=\"$archive_link/$file\">$file</a>\n";
   }
   unless($links) {$links = "<li>Sorry, no matches.";}
}

sub Success {
  #Prints results of search
print <<"EOF";
$header

<! doctype html public "-//W3O//DTD W3 html 2.0//en">
<html><head>
<title>VOH // Search Results for $in{search}</title>
</head>
<body bgcolor="#FFFFFF">
<a name="TOP"></a>
<center>
<h1>Search Results for $in{search}</h1>
</center>
<ul>
$links
</ul>
<center>
<hr>
<a href="/VOH/"><img src="/uclavoh/images/voh-icon.gif"
width=60 height=60 alt="[[VOH Home Page]" align="center]"></a>
<a href="#TOP"><img src="/VOH/images/top-icon.gif"
width=60 height=60 alt="[[Top]" align="center]"></a>
<hr>
<a href="/VOH/docs/mjw.html">mjw</a> //
<a href="/VOH/docs/contributers.html">voh\@chem.ucla.edu</a> //
</center></body>
</html>
EOF
   exit;
}
sub Failure {
   local ($error, $html, $reason) = @_ ;
   FAILURE: {
   $error_text1 ="Unable to open archive directory!" ;
   $error_text5 ="Must use the POST method for form submission!" ;

   ($error == 1) && ($reason = $error_text1, last FAILURE);
   ($error == 5) && ($reason = $error_text5, last FAILURE);
   $reason = "Unknown error!" ;
   }
print <<"EOE";
$header
<html><head>
<title>VOH // Failure!</title></head>
<body bgcolor="#FFFFFF">
<h1>Form Submission Failed!</h1>
<hr>
<p>$reason
<hr>
</body></html>
EOE

   exit ;
}

# End all.....


